<?php
//quellen: IPS-Tasmota, Astronomie-Modul, SymconBTP, tankerkoenig-php-client
require_once __DIR__ . '/../libs/IPSTankerLib.php';

class IPSTanker extends IPSTankerLib
{

    private $Tankstellen = array();

    public function Create()
    {
        parent::Create();
        $location = $this->getlocation($this->InstanceID);	
        $this->RegisterPropertyFloat('lat', $location['Latitude']);
	$this->RegisterPropertyFloat('long', $location['Longitude']);
	$this->RegisterPropertyFloat('radius', 3.00);
	$this->RegisterPropertyString('type', 'all');
	$this->RegisterPropertyBoolean('changename', true);
	$this->RegisterPropertyBoolean('archiv',false);
	$this->Tankstellen = array();
	$this->RegisterVariableString("ID", "ID");
	$this->RegisterVariableString("name", "Name");
	$this->RegisterVariableString("brand", "Marke");
	$this->RegisterVariableString("street", "Strasse");
	$this->RegisterVariableString("houseNumber", "Hausnummer");
	$this->RegisterVariableString("postCode", "PLZ");
	$this->RegisterVariableString("place", "Ort");
	$this->RegisterVariableString("open1", "Öffnungszeit Mo-Fr");
	$this->RegisterVariableString("open2", "Öffnungszeit Sa");
	$this->RegisterVariableString("open3", "Öffnungszeit So");
	$this->RegisterVariableString("overrides", "Öffnungszeit Ausnahme");
	$this->RegisterVariableBoolean("wholeDay", "ganztägig");
	$this->RegisterVariableBoolean("isOpen", "geöffnet");
	$this->RegisterVariableFloat("e5", "Benzin E5","Euro");
	$this->RegisterVariableFloat("e10", "Benzin E10","Euro");
	$this->RegisterVariableFloat("diesel", "Diesel","Euro");
	$this->RegisterVariableFloat("lat", "Latitude");
	$this->RegisterVariableFloat("lng", "Longitude");
	$this->RegisterVariableString("state", "Bundesland");
    }

    public function ApplyChanges()
    {
        parent::ApplyChanges();
	$this->SetBuffer('Tankstellen', serialize($this->Tankstellen));
    }


    public function GetConfigurationForm()
    {

	$Tankstellen = unserialize($this->GetBuffer('Tankstellen'));
	if (count($Tankstellen) == 0) {
           $this->Scan();
	   $Tankstellen = unserialize($this->GetBuffer('Tankstellen'));
	}
	$List = array();
	$data = json_decode(file_get_contents(__DIR__ . '/form.json'),true);
	
	$i = 0;
	foreach ($Tankstellen as $TankstellenID) {
		$Listarray = array(
                	'TankerMarke' => $Tankstellen[$i]->brand,
                	'TankerOrt' => $Tankstellen[$i]->place,
			'TankerStrasse' => $Tankstellen[$i]->street,
                	'TankerName'  => $Tankstellen[$i]->name,
                	'InstanceID'   => $Tankstellen[$i]->id
            	);
		$List[] = $Listarray;
		$i++;
	}

	$data['actions'][0]['values'] = array_merge($data['actions'][0]['values'], $List);

	$data['actions'][3]['onClick'] = '
        	if ($Tankstellenliste["InstanceID"] == "") 
            	{
            		echo "Keine Tankstelle ausgewählt!";
            		return;
            	}


                if ($archiv == true){
			$ArchiveID = IPS_GetInstanceListByModuleID("{43192F0B-135B-4CE7-A0A7-1475603F3060}")[0];
                        $VarID =  IPS_GetObjectIDByIdent ("e5",$id);
                        AC_SetLoggingStatus($ArchiveID, $VarID, true);
                        $VarID =  IPS_GetObjectIDByIdent ("e10",$id);
                        AC_SetLoggingStatus($ArchiveID, $VarID, true);
                        $VarID =  IPS_GetObjectIDByIdent ("diesel",$id);
                        AC_SetLoggingStatus($ArchiveID, $VarID, true);
                }

		if ($changename == true)
                {
		IPS_SetName ($id , $Tankstellenliste["TankerMarke"]." - ".$Tankstellenliste["TankerOrt"]);
		}
		$TankerID = IPS_GetObjectIDByIdent ("ID",$id);
		SetValueString($TankerID,  $Tankstellenliste["InstanceID"]);
	        TANKER_GetDetails($id);
	';
	return json_encode($data);
    }

public function Scan()
    {
 	$APIKey = $this->getapikey($this->InstanceID);
	$lat = $this->ReadPropertyFloat('lat');
        $long = $this->ReadPropertyFloat('long');
        $radius = $this->ReadPropertyFloat('radius');
        $type = $this->ReadPropertyString('type');
	if ($APIKey == '') { return; }
	$result = json_decode(file_get_contents("https://creativecommons.tankerkoenig.de/json/list.php?lat=$lat&lng=$long&rad=$radius&sort=dist&type=$type&apikey=$APIKey"));
	$result_array = $result->stations;	
	$this->SetBuffer('Tankstellen', serialize($result_array));
    }

public function GetDetails()
   {
        $MyId = $this->InstanceID;
        $APIKey = $this->getapikey($this->InstanceID);
        $TankerID = IPS_GetObjectIDByIdent ("ID",$MyId);
        $StringID = GetValueString($TankerID);
        if ($StringID == '') { return; }
        $result = json_decode(file_get_contents("https://creativecommons.tankerkoenig.de/json/detail.php?id=$StringID&apikey=$APIKey"));
        $result_array = $result->station;
	$TankerID = IPS_GetObjectIDByIdent ("name",$this->InstanceID);	
	SetValueString($TankerID, $result_array->name);
        $TankerID = IPS_GetObjectIDByIdent ("brand",$this->InstanceID);
        SetValueString($TankerID, $result_array->brand);
        $TankerID = IPS_GetObjectIDByIdent ("street",$this->InstanceID);
        SetValueString($TankerID, $result_array->street);
        $TankerID = IPS_GetObjectIDByIdent ("houseNumber",$this->InstanceID);
        SetValueString($TankerID, $result_array->houseNumber);
        $TankerID = IPS_GetObjectIDByIdent ("postCode",$this->InstanceID);
        SetValueString($TankerID, $result_array->postCode);
        $TankerID = IPS_GetObjectIDByIdent ("place",$this->InstanceID);
        SetValueString($TankerID, $result_array->place);
	$opencount =  count($result_array->openingTimes);
	$TankerID = IPS_GetObjectIDByIdent ("open1",$this->InstanceID);
        if ($opencount >= 1) {
        	SetValueString($TankerID, $result_array->openingTimes[0]->start . "-" . $result_array->openingTimes[0]->end);
        }
	else {
		SetValueString($TankerID,"N/A");
	}
	$TankerID = IPS_GetObjectIDByIdent ("open2",$this->InstanceID);
        if ($opencount >= 2) {
        	SetValueString($TankerID, $result_array->openingTimes[1]->start . "-" . $result_array->openingTimes[1]->end);
	}
        else {
                SetValueString($TankerID,"N/A");
        }
	$TankerID = IPS_GetObjectIDByIdent ("open3",$this->InstanceID);
        if ($opencount >= 3) {
 	        SetValueString($TankerID, $result_array->openingTimes[2]->start . "-" . $result_array->openingTimes[2]->end);
	}
        else {
                SetValueString($TankerID,"N/A");
        }

//Overrides nicht getestet !!!
       	$TankerID = IPS_GetObjectIDByIdent ("overrides",$this->InstanceID);
	$overridecount = count($result_array->overrides);
	if($overridecount >= 1){
        	SetValueString($TankerID, $result_array->overrides[0]);
	}
        else {
                SetValueString($TankerID,"");
        }
//bis hier noch testen
        $TankerID = IPS_GetObjectIDByIdent ("wholeDay",$this->InstanceID);
        SetValueBoolean($TankerID, $result_array->wholeDay);
        $TankerID = IPS_GetObjectIDByIdent ("isOpen",$this->InstanceID);
        SetValueBoolean($TankerID, $result_array->isOpen);
        $TankerID = IPS_GetObjectIDByIdent ("e5",$this->InstanceID);
        SetValueFloat($TankerID, $result_array->e5);
        $TankerID = IPS_GetObjectIDByIdent ("e10",$this->InstanceID);
        SetValueFloat($TankerID, $result_array->e10);
        $TankerID = IPS_GetObjectIDByIdent ("diesel",$this->InstanceID);
        SetValueFloat($TankerID, $result_array->diesel);
        $TankerID = IPS_GetObjectIDByIdent ("lat",$this->InstanceID);
        SetValueFloat($TankerID, $result_array->lat);
        $TankerID = IPS_GetObjectIDByIdent ("lng",$this->InstanceID);
        SetValueFloat($TankerID, $result_array->lng);
        $TankerID = IPS_GetObjectIDByIdent ("state",$this->InstanceID);
        SetValueString($TankerID, $result_array->state);
   }
}
